config/routes.rb
Rails.application.routes.draw do

  root to: 'events#index'

  resources :events,       only: [:index, :show, :update]
  resources :meta_events,  only: [:index, :new, :create, :edit, :update]
  resources :room_prices,  only: [:index, :new, :create, :edit, :update] # fixme - update?
  resources :rooms,        only: [:index, :new, :create, :show, :edit, :update]
  resources :bands,        only: [:index, :new, :create, :show, :edit, :update]
  resources :musicians,    only: [:index, :new, :create, :show, :edit, :update]

end

app/models/band.rb
class Band < ActiveRecord::Base
  has_many :reservations
  validates :name, presence: true
  validates_uniqueness_of :name
end

app/controllers/bands_controller.rb
class BandsController < ApplicationController
  before_action :set_band, only: [:show, :edit, :update, :destroy]

  # GET /bands
  # GET /bands.json
  def index
    @bands = Band.all
  end

  # GET /bands/1
  # GET /bands/1.json
  def show
  end

  # GET /bands/new
  def new
    @band = Band.new
  end

  # GET /bands/1/edit
  def edit
  end

  # POST /bands
  # POST /bands.json
  def create
    @band = Band.new(band_params)

    respond_to do |format|
      if @band.save
        format.html { redirect_to @band, notice: 'Band was successfully created.' }
        format.json { render :show, status: :created, location: @band }
      else
        format.html { render :new }
        format.json { render json: @band.errors, status: :unprocessable_entity }
      end
    end
  end

  # PATCH/PUT /bands/1
  # PATCH/PUT /bands/1.json
  def update
    respond_to do |format|
      if @band.update(band_params)
        format.html { redirect_to @band, notice: 'Band was successfully updated.' }
        format.json { render :show, status: :ok, location: @band }
      else
        format.html { render :edit }
        format.json { render json: @band.errors, status: :unprocessable_entity }
      end
    end
  end

  # DELETE /bands/1
  # DELETE /bands/1.json
  def destroy
    @band.destroy
    respond_to do |format|
      format.html { redirect_to bands_url, notice: 'Band was successfully destroyed.' }
      format.json { head :no_content }
    end
  end

  private
    # Use callbacks to share common setup or constraints between actions.
    def set_band
      @band = Band.find(params[:id])
    end

    # Never trust parameters from the scary internet, only allow the white list through.
    def band_params
      params.require(:band).permit(:name)
    end
end

app/helpers/bands_helper.rb
module BandsHelper
end

app/views/bands/_form.html.erb
<%= form_for(@band) do |f| %>
  <% if @band.errors.any? %>
    <div id="error_explanation">
      <h2><%= pluralize(@band.errors.count, "error") %> prohibited this band from being saved:</h2>

      <ul>
      <% @band.errors.full_messages.each do |message| %>
        <li><%= message %></li>
      <% end %>
      </ul>
    </div>
  <% end %>

  <div class="field">
    <%= f.label :name %><br>
    <%= f.text_field :name %>
  </div>
  <div class="actions">
    <%= f.submit %>
  </div>
<% end %>

app/views/bands/edit.html.erb
<h1>Editing band</h1>

<%= render 'form' %>

<%= link_to 'Show', @band %> |
<%= link_to 'Back', bands_path %>

app/views/bands/index.html.erb
<h3>Listing bands</h3>

<table>
  <thead>
    <tr>
      <th>Name</th>
      <th colspan="3"></th>
    </tr>
  </thead>

  <tbody>
    <% @bands.each do |band| %>
      <tr>
        <td><%= band.name %></td>
        <td><%= link_to 'Show', band %></td>
        <td><%= link_to 'Edit', edit_band_path(band) %></td>
        <td><%= link_to 'Destroy', band, method: :delete, data: { confirm: 'Are you sure?' } %></td>
      </tr>
    <% end %>
  </tbody>
</table>

<br>

<%= link_to 'New Band', new_band_path %>

app/views/bands/new.html.erb
<h1>New band</h1>

<%= render 'form' %>

<%= link_to 'Back', bands_path %>

app/views/bands/show.html.erb
<p id="notice"><%= notice %></p>

<p>
  <strong>Name:</strong>
  <%= @band.name %>
</p>

<%= link_to 'Edit', edit_band_path(@band) %> |
<%= link_to 'Back', bands_path %>